QGIS Application - Bug report #8356
VRT file opens instantly in 1.8, not opened after 10 mins on Master
2013-07-24 04:02 AM - James Stott

Status: Closed

Priority: Severe/Regression

Assignee:

Category:

Affected QGIS version:master Regression?: No
Operating System: Easy fix?: No
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 17136
Description

| am trying to open a vrt file in Master. It is made up of 348 jpg files (each file ranging in size from 4 - 60mb).

The vrt file has overviews built on it (which is obviously a rather large file), but on QGIS 1.8 it opens almost instantaneously once | have
confirmed the CRS to use. | can also pan around and the screen refreshes instantly.

Attached is the output of gdalinfo for the vrt.

| also have other vrt files that are doing the same thing. So its not just the one file.

Taking one of the individual jpgs on its own (a 47mb file), 1.8 opens it in 17 secs, and master in 21 secs - so not a massive difference for a
single file (and certainly not the most scientific of tests on my part).

Marked as a blocker as to me it seems like a regression from 1.8. Please change if needed.

Associated revisions

Revision 299d152e - 2013-07-27 09:28 AM - Radim Blazek

Workaround for GDAL ticket 5170, fixes #8356

Revision 83d15a51 - 2013-08-13 09:24 AM - Radim Blazek

Disable VSI cache before GDALRasterlO, workaround for GDAL ticket 5170, fixes #8356

Revision 6ala4be7 - 2013-08-18 12:00 PM - Radim Blazek

Disable VSI cache before GDALGetOverviewCount, workaround for GDAL ticket 5170, hopefully fixes #8356

History

#1 - 2013-07-24 03:01 PM - Nathan Woodrow

Do you have raster icons turned on?

http://i.imgur.com/XSqkk46.png
#2 - 2013-07-25 12:15 AM - James Stott

| did have that turned on yes. Is that a default setting as | don't remember turning it on? Should it be the default setting if it slows things down?

But | have unticked it and master still displays the same behavior as before (unopened after 10 mins). So this was not the cause of the problem.

Is there any logging info | can supply to help find why this is happening?

#3 - 2013-07-25 05:25 AM - Radim Blazek

What renderer type and contrast enhancement are set when it opens?

Ho fast is it if you switch of rendering (check off Render in status bar) before you open the raster?

How fast is the second display refresh (whole extent)?

How fast is it to render a small part (possibly an area just from a single tile file but from VRT).

Which pyramids (overviews) are listed in raster properties Pyramids tab?

How fast is it to open the overviews file alone (Stavanger_2011.vrt.ovr)?

Are you able to deduce from the debug log what is happening all that time.

#4 - 2013-07-25 06:12 AM - James Stott
- File unsupported_data_source.jpg added

What renderer type and contrast enhancement are set when it opens?

| haven't been able to get layers properties to open to find out.

Ho fast is it if you switch of rendering (check off Render in status bar) before you open the raster?

Opens quickly and appears in the layer tree, but properties takes too long to open. | gave up after 10 mins.

How fast is the second display refresh (whole extent)?

Haven't been able to achieve this far with the whole extent.

| How fast is it to render a small part (possibly an area just from a single tile file but from VRT).

It opened in just over 1 minute (the tiles are 800m x 600m). Pretty much the same rendering time if | move the map.

Which pyramids (overviews) are listed in raster properties Pyramids tab?
Properties wont open after 10 mins of waiting.

How fast is it to open the overviews file alone (Stavanger_2011.vrt.ovr)?

This generates a unsupported data source dialog (see attached jpg). Maybe this is the problem?

Are you able to deduce from the debug log what is happening all that time.

QGIS just freezes if | have rendering turned on, or if open layer properties, so | cannot see what the log says. When | get it to open zoomed right in, QGIS

does not post any error messages to the error log.

| have been able to get some of my other data to open. | also created a vrt and overviews for some new data | have received and it worked fine in master.

| am currently rebuilding the vrt and overviews on the Stavanger 2011 file and will report back tomorrow (it will not be finished before | finish work today).

#5 - 2013-07-25 06:28 AM - Radim Blazek

James Stott wrote:

What renderer type and contrast enhancement are set when it opens?

| haven't been able to get layers properties to open to find out.

Probably it takes too long to generate thumbnail.

Ho fast is it if you switch of rendering (check off Render in status bar) before you open the raster?

Opens quickly and appears in the layer tree, but properties takes too long to open. | gave up after 10 mins.

That means that rendering is slow, not calculating stats etc.

How fast is it to open the overviews file alone (Stavanger _2011.vrt.ovr)?

This generates a unsupported data source dialog (see attached jpg). Maybe this is the problem?

It seems to be. It looks like the ovr file is in a format which is not supported by your QGIS build, strange however that it is reported correctly by GDAL, is it

using the same GDAL lib?

#6 - 2013-07-26 01:38 AM - James Stott

It seems to be. It looks like the ovr file is in a format which is not supported by your QGIS build, strange however that it is reported correctly by

GDAL, is it using the same GDAL lib?

It was using the OSGeo4W shell that | ran gdalinfo (which reports GDAL 1.9.2). If | go into the about dialog in QGIS, QGIS 1.8 and QGIS Master both state
GDAL 1.9.2.
If I run GDAL info from Raster > Miscellaneous > Information here are the results:

QGIS 1.8 - reports the vrt files has overviews when trying to open the vrt file. The ovr file reports these too.
QGIS 1.9 - does not report overviews when querying the vrt file. The ovr file generates the same error in the attached jpg unsupported_data_source.jpg

The errors from master are:

ERROR 1: TIFFFetchDirectory:Sanity check on directory count failed, this is probably not a valid IFD offset
ERROR 1: TIFFReadDirectory:Failed to read directory at offset 17891712530

So is QGIS master running a different version of GDAL than 1.9.2?
The file works in QGIS v1.8 (and it opens in ArcMap 10.1 SP1), so there does seem to be a problem with the overview file specific to master.

Very strange.

#7 - 2013-07-26 02:42 AM - Radim Blazek
James Stott wrote:
It was using the OSGeo4W shell that | ran gdalinfo (which reports GDAL 1.9.2). If | go into the about dialog in QGIS, QGIS 1.8 and QGIS Master
both state GDAL 1.9.2.
Than it should be the same GDAL. In theory, the same versions of GDAL may be compiled with different drivers but if both versions of QGIS are installed
via OSGeo4W, they should be using the same GDAL lib.

The errors from master are:

ERROR 1: TIFFFetchDirectory:Sanity check on directory count failed, this is probably not a valid IFD offset
ERROR 1: TIFFReadDirectory:Failed to read directory at offset 17891712530

So is QGIS master running a different version of GDAL than 1.9.27

One difference came to mind. To improve performance of Shapefiles over network | added to the start up batch some GDAL VS| variables. Please try to

disable them, comment or delete in your ggis-dev.bat the rows:

set VSI_CACHE=TRUE

set VSI_CACHE_SIZE=1000000

#8 - 2013-07-26 03:27 AM - James Stott

One difference came to mind. To improve performance of Shapefiles over network | added to the start up batch some GDAL VSl variables. Please

try to disable them, comment or delete in your qgis-dev.bat the rows:

set VSI_CACHE=TRUE
set VSI_CACHE_SIZE=1000000

You have hit the nail right on the head.
It works with these two lines commented out/deleted.

Seeing as we rarely use shapefiles, | shall leave them commented out.

#9 - 2013-07-26 04:21 AM - Radim Blazek

| have sent a question to GDAL: http://lists.osgeo.org/pipermail/gdal-dev/2013-July/036741.html

#10 - 2013-07-27 12:28 AM - Radim Blazek
- Status changed from Open to Closed

Fixed in changeset commit:"299d152e2f6ddb626691ed7d66€99e21724b4832".

#11 - 2013-07-27 12:32 AM - Radim Blazek

It was fixed in GDAL: http://trac.osgeo.org/gdal/ticket/5170 for future 1.9.3 and 1.10.1.

| have fixed that also in QGIS as Even recommended.

James, please test again with next nightly build and qgis-dev.bat not modified (i.e. with VSI cache globally enabled).

#12 - 2013-07-28 11:39 PM - James Stott
- Status changed from Closed to Reopened

| updated master this morning (29/07/2013) and this has not fixed the problem. Commenting out the lines still works.

#13 - 2013-07-28 11:44 PM - Paolo Cavallini

Please check which version you are actually using - it is possible that the fix came in later.

#14 - 2013-07-28 11:58 PM - James Stott

| am using 779592 (stated as 1.9.0-345 in the OSGeo4W installer). | do not know if this is before or after the fix.

#15 - 2013-07-29 12:48 AM - Salvatore Larosa
- Status changed from Reopened to Closed

Please try with commit:299d152 or next, your revision is before the fix!

#16 - 2013-07-29 01:12 AM - James Stott

Salvatore Larosa wrote:
http://lists.osgeo.org/pipermail/gdal-dev/2013-July/036741.html
http://trac.osgeo.org/gdal/ticket/5170

Please try with commit:299d152 or next, your revision is before the fix!

Thanks. Will check once the update becomes available.

#17 - 2013-07-30 12:15 AM - James Stott

- Status changed from Closed to Reopened

Apologies about yesterdays false alarm. | have learnt something new about the way the versioning works :)

Today | have tried with a13cdf8, which | believe has the fix implemented.

Slightly different behaviour.

| cannot load the vrt file - | gave up after 10 mins of waiting.

But | can open the overview file fine (it loads instantly once | have selected a CRS).

Commenting out the two lines in the qgis-dev.bat file still allows me to open the vrt.

#18 - 2013-08-02 05:54 AM - Radim Blazek

It means that Even was right, the VSI cache has to be disabled also before each read data call, GDAL does not keep the overview file open.

Easy fix, just to do the same what was done for GDALOpen also for GDALRasterlO.

| cannot fix that however before the 13th of August.

#19 - 2013-08-13 12:25 AM - Radim Blazek

- Status changed from Reopened to Closed

Fixed in changeset commit:"83d15a51ff279e31c81ceb56fcc83a153ef82327".

#20 - 2013-08-14 11:31 PM - James Stott

Thanks Radim.

| will test once qgis-dev updates (hasn't updated for a few days now).

#21 - 2013-08-16 06:15 AM - James Stott
- Status changed from Closed to Reopened

Tested with 469997 just now. This does not fix opening of VRT files. It loads fine if you open the .ovr file directly, but not the vrt file. | closed QGIS down
after waiting for 10 minutes.

2025-04-27 6/7



Commenting out the VSl lines in the bat file enables the vrt file to load.

#22 - 2013-08-18 03:01 AM - Radim Blazek
- Status changed from Reopened to Closed

Fixed in changeset commit:"6a1a4be72223df55996bb2fb403c9515¢807bc25".

#23 - 2013-08-18 03:06 AM - Radim Blazek

| found that OVR files is opened neither in GDALOpen nor in GDALRasterlO but in GDALGetOverviewCount so | wrapped that function as well.

James, please test once more, thanks for patience.

#24 - 2013-08-18 11:33 PM - James Stott

Thanks for continuing to look at the problem!

This has now fixed the problem. Vrt files with ovr files now open instantly with master.

Files

gdalinfo_ouput.txt 10.6 KB 2013-07-24 James Stott

unsupported_data_source.jpg 47.8 KB 2013-07-25 James Stott
